addHook("PreThinkFrame", function()
	for p in players.iterate do
		if p.valid then
			
			if p.srbc == nil then
				p.srbc = {}
				
				p.srbc.storedMomentum = {x = 0, y = 0, z = 0}
				p.srbc.storedAngle = 0
				p.srbc.storedQuit = 0
				p.srbc.nerfed = 0
				p.srbc.grace = 1
				p.srbc.laps = 0
				p.srbc.laptimes = {}
				p.srbc.timeaverage = 0
				p.srbc.overtime = 0
				p.srbc.deaths = 0
				p.srbc.over = 0
				p.srbc.lose = false
				p.srbc.endinfo = {score = 0, rings = 0, laps = 0, done = false}
				
				if SRBC.gamestate.started then
					if SRBC.gamestate.overtime or SRBC.gamestate.laststanding then
						SRBC:PlayerFinish(p, true)
					else
						p.srbc.ghost = {
							timer = 0,
							sprite = nil,
							freezeframe = nil
						}
					end
				end
				
			end
		end
	end
end)



addHook("MapLoad", function()
	if not SRBC:IsChasers() then return end
	
	local spawn = nil
	local goal = nil
	
	for thing in mapthings.iterate do
		if thing.valid and thing.type == 1 then spawn = thing end
		if thing.valid and thing.type == 501 then goal = thing end
	end
	
	SRBC.start = {x = spawn.x*FU, y = spawn.y*FU, z = R_PointInSubsector(spawn.x*FU, spawn.y*FU).sector.floorheight + spawn.z*FU, angle = spawn.angle*ANG1}
	SRBC.finish = {x = goal.x*FU, y = goal.y*FU, z = R_PointInSubsector(goal.x*FU, goal.y*FU).sector.floorheight + goal.z*FU, angle = goal.angle*ANG1, flip = goal.options & MTF_OBJECTFLIP}
end)