--!! A lot of this is client code!!

function SRBC:UpdateMusic()
	if SRBC.gamestate.started then
		if SRBC.gamestate.overtime then
			mapmusname = SRBC_CONVAR.music[SRBC_CONVAR.musicProfile].overtime
		else
			mapmusname = SRBC_CONVAR.music[SRBC_CONVAR.musicProfile].game
		end
		
		S_ChangeMusic(mapmusname, true, consoleplayer)
	end
end

function SRBC:PlayJingle(music, duration)
	P_PlayJingleMusic(consoleplayer, music, 0, false)
	SRBC.jingleTime = max(duration + 1, 2)
end

addHook("PlayerJoin", function(pnum)
	if pnum == #consoleplayer then
		SRBC:UpdateMusic()
	end
end)

addHook("PlayerThink", function(p)
	if not p.valid then return end
	
	if p.quittime < p.srbc.storedQuit and p == consoleplayer then
		SRBC:UpdateMusic()
	end
		
	p.srbc.storedQuit = p.quittime
end)



addHook("ThinkFrame", function()
	if not SRBC:IsChasers() then return end
	
	SRBC.jingleTime = max($-1, 0)
	
	if SRBC.jingleTime == 1 then
		P_RestoreMusic(consoleplayer)
	end
	
	if S_MusicName(consoleplayer) != "_inv" and S_MusicName(consoleplayer) != "_shoes" and S_MusicName(consoleplayer) != "_1up" then
		SRBC.musicTime = S_GetMusicPosition()
	else
		S_ChangeMusic(mapmusname, true, consoleplayer, 0, SRBC.musicTime + 20)
	end
end)