COM_AddCommand("srbc_showlaps", function(p)
	SRBC_CONVAR.showlaps = not SRBC_CONVAR.showlaps
	print("Laps display set to "..tostring(SRBC_CONVAR.showlaps))
end, COM_LOCAL)

COM_AddCommand("srbc_screenshake", function(p, mult)
	if tonumber(mult) then SRBC_CONVAR.screenshake = tonumber(mult) end
	print("Screenshake and tilt multiplier set to "..tostring(SRBC_CONVAR.screenshake))
end, COM_LOCAL)

COM_AddCommand("srbc_music", function(p, profile)
	if profile == nil then
		print()
		print("List of profiles:")
		print()
		for name, data in pairs(SRBC_CONVAR.music) do
			print("\x86[\x82"..name.."\x86]\x80 :: "..data.description)
		end
	return end
	if SRBC_CONVAR.music[profile] then
		SRBC_CONVAR.musicProfile = profile
		print("Music profile set to "..profile)
	else
		print("Invalid name")
	end
end, COM_LOCAL)

COM_AddCommand("srbc_customizemusic", function(p, chase, overtime)
	if chase == nil then
		print()
		print("Current tracks:")
		print()
		print("\x86[\x82"..SRBC_CONVAR.music.custom.game.."\x86]\x80 :: Chase")
		print("\x86[\x82"..SRBC_CONVAR.music.custom.overtime.."\x86]\x80 :: Overtime")
	return end
	
	if type(chase) == "string" and S_MusicExists(chase:upper()) then SRBC_CONVAR.music.custom.game = chase:upper(); print("Game music set to "..chase:upper()) end
	if type(overtime) == "string" and S_MusicExists(overtime:upper()) then SRBC_CONVAR.music.custom.overtime = overtime:upper(); print("Overtime music set to "..overtime:upper()) end
	
	SRBC_CONVAR.musicProfile = "custom"
end, COM_LOCAL)

if SRBC.debug then
	COM_AddCommand("srbc_start", function(p, seconds)
		seconds = tonumber(seconds)
		if seconds then seconds = $*TICRATE end
		SRBC:StartGame(seconds, p)
	end, COM_ADMIN)

	COM_AddCommand("srbc_overtime", function(p)
		if not SRBC:IsChasers() or not SRBC.gamestate.started then return end
		if SRBC.gamestate.overtime then return end
	
		SRBC.gameinfo.maxtimer = SRBC:SinceStart()
		SRBC:StartOvertime()
	end, COM_ADMIN)

	COM_AddCommand("srbc_lap", function(p)
		SRBC:Lap(p)
	end, COM_ADMIN)

	COM_AddCommand("srbc_nerf", function(p)
		p.srbc.nerfed = max($, 1)
	end)
	
	COM_AddCommand("srbc_jingletest", function(p)
		SRBC:PlayJingle("_CLEAR", TICRATE*6)
	end, COM_ADMIN|COM_LOCAL)
	
	COM_AddCommand("srbc_respawn", function(p)
		SRBC:RespawnEnemies()
	end, COM_ADMIN)
	
	COM_AddCommand("srbc_revive", function(p)
		SRBC:ReviveGhost(p, p)
	end, COM_ADMIN)
	
	COM_AddCommand("srbc_finish", function(p)
		SRBC:PlayerFinish(p, false)
	end, COM_ADMIN)
end