addHook("MapLoad", function()
	if not SRBC:IsChasers() then return end
	
	for p in players.iterate do
		if not p.valid then return end
		
		p.srbc.nerfed = 0
	end
end)

addHook("PostThinkFrame", function()
	if not SRBC:IsChasers() then return end
	
	for p in players.iterate do
		if not SRBC:IsPlayerMobj(p) then return end
		
		if p.srbc.nerfed > 0 then
			if p.srbc.nerfed == 1 then
				S_StartSound(nil, sfx_antiri, p)
				P_AddPlayerScore(p, 5 * p.rings)
				p.srbc.nerfed = 2
			end
			
			if (p.mo.eflags & MFE_UNDERWATER) then p.powers[pw_shield] = 0 end
			p.rings = 0
		end
	end
end)